#!/bin/sh
# Z2 backup script v0.3
# Copyright (C) 2010 Marek Vasut <marek.vasut@gmail.com>
#
# This is under GPL v3
#
# Modified by mozzwald http://www.mozzwald.com

# filenames
flashdefdir=/mnt/mmcblk0p1/u-boot
restoredir="$flashdefdir/`date +%m%d%Y_%H%m%S`"

# Versions and Dialog settings
SCRIPTNAME="Z2uFlasher"
SCRIPTVER="v0.3"
DIALOGRC=/mnt/mmcblk0p1/etc/.dialogrc
DIALOGSIZE="12 38"
BACKTITLE="$SCRIPTNAME $SCRIPTVER  |  Backup"

# Info
dialog $BEGIN --backtitle "$BACKTITLE" --msgbox "This will create a backup of your exisiting flash partitions to $restoredir" $DIALOGSIZE
	
# make restore directory
mkdir "$restoredir"

# fix mtdblock partitions, create partition list and backup old flash
flashsz=0
while read line; do
        i=`echo $line | grep mtdblock | cut -d " " -f 4`
        if [ -n "$i" ]; then
		# fix the mtdblock
		#echo "Fixing /dev/$i"
		blocknum=`echo "$i" | sed -e "s/^.*\(.\)$/\1/"`
		if [ -e "/dev/$i" ]; then
			rm "/dev/$i"
		fi
		mknod "/dev/$i" b 31 "$blocknum"
		# write the partition list
		partsz=`wc -c "/dev/$i" | sed -r "s/[[:blank:]]*([[:digit:]]+).*/\1/"`
		#echo "/dev/$i $partsz" >> "$partlist"
		# Backup Partitions & Create flash.def
		(/mnt/mmcblk0p1/bin/pv-u -n "/dev/$i" | dd of="$restoredir/$i.bak") 2>&1 | dialog $BEGIN --backtitle "$BACKTITLE" --gauge "Backing up /dev/$i" $DIALOGSIZE 0
		#dialog $BEGIN --backtitle "$BACKTITLE" --infobox "Backing up /dev/$i" $DIALOGSIZE
		#dd if="/dev/$i" of="$restoredir/$i.bak"
	        mtdmd5=`md5sum "$restoredir/$i.bak" | cut -d " " -f 1`
	        echo "$i.bak $flashsz $mtdmd5" >> "$restoredir"/flash.def
		flashsz=`expr "$flashsz" + "$partsz"`
		mtdcount=`expr "$blocknum" + 1`
	fi
done </proc/partitions

dialog $BEGIN --backtitle "$BACKTITLE" --msgbox "Backup complete and saved to $restoredir" $DIALOGSIZE
