################################################
# ZipitZ2 blob (stock) to u-boot flasher shell #
# z2script.sh (c) 2009-2011 Russell K. Davis   #
################################################
# setup some environment variables
export PATH=/mnt/sd0/bin:$PATH
export TERM=xterm-color
export TERMINFO=/etc/terminfo
# create busybox symlinks
/mnt/sd0/bin/busybox.sh

# load kernel modules
insmod /mnt/sd0/modules/zipit2_kbd_helper.ko
insmod /mnt/sd0/modules/pxa27x_keyboard.ko
insmod /mnt/sd0/modules/softcursor.ko
insmod /mnt/sd0/modules/fbcon_ud.ko
insmod /mnt/sd0/modules/fbcon_cw.ko
insmod /mnt/sd0/modules/fbcon_ccw.ko
insmod /mnt/sd0/modules/fbcon_rotate.ko
insmod /mnt/sd0/modules/bitblit.ko
insmod /mnt/sd0/modules/font.ko
insmod /mnt/sd0/modules/fbcon.ko
insmod /lib/gpio_driver.ko

# create and mount the sysfs
mkdir /sys
mount -t sysfs sysfs /sys

# rotate the fbcon
echo 3 > /sys/class/graphics/fbcon/rotate

# splashscreen
fbsplash -s /mnt/sd0/etc/logo.ppm -c
sleep 5

# make device nodes in /dev
mknod /dev/tty0 c 4 0
rm /dev/tty
mknod /dev/tty c 5 0 
mknod /dev/ptmx c 5 2
chmod 666 /dev/ptmx
mkdir /dev/pts
mount -t devpts devpts /dev/pts
mknod /dev/ttyp0 c 3 0
mknod /dev/ptyp0 c 2 0
mknod /dev/ttyp1 c 3 1
mknod /dev/ptyp1 c 2 1
mknod /dev/ttyp2 c 3 2
mknod /dev/ptyp2 c 2 2
mknod /dev/ttyp3 c 3 3
mknod /dev/ptyp3 c 2 3
mknod /dev/pty c 2 176
mknod /dev/ptya0 c 2 177
mknod /dev/tty1 c 4 1
mknod /dev/tty2 c 4 2
mknod /dev/tty3 c 4 3

# tidy up all the various directory links
ln -s /mnt/sd0/etc/* /etc/
ln -s /mnt/sd0/var /var
ln -s /mnt/sd0/lib/* /lib
if test ! -d /usr
then
        mkdir /usr
fi
ln -s /mnt/sd0/lib /usr/lib
if test ! -d /usr/local
then 
	mkdir -p /usr/local
fi 
ln -s /mnt/sd0/lib /usr/local/lib
ln -s /mnt/sd0/bin /usr/local/bin
ln -s /mnt/sd0/bin /usr/local/sbin
ln -s /mnt/sd0/etc /use/local/etc
#ln -s /mnt/sd0/share /share
#ln -s /mnt/sd0/share/* /usr/share/
#ln -s /mnt/sd0/share /usr/local/share

# remap the keyboard
/mnt/sd0/bin/loadkeys < /mnt/sd0/etc/keymap.map 

# turn off the broken console screen blanker
echo -ne "\033[9;0]" >/dev/tty0

# turn off cursor
echo -ne "\033[?25l" >/dev/tty0

# load a larger font so that the dialog screens are readable
#setfont /mnt/sd0/fonts/LatArCyrHeb-16.psf
setfont /mnt/sd0/fonts/Lat15-Terminus12x6.psf
clear > /dev/tty0

cls > /dev/tty0
cp /mnt/sd0/bin/bash /bin/bash
echo "\033[?25h" >/dev/tty0

# Menu
#SCRIPTNAME="Flashstock"
#SCRIPTVER="v0.3"
#DIALOGRC=/mnt/sd0/etc/.dialogrc
#DIALOGSIZE="12 38"
#BACKTITLE="$SCRIPTNAME $SCRIPTVER  |  Menu"
#dialog $BEGIN --backtitle "$BACKTITLE" --menu "Choose an option:" $DIALOGSIZE 10 1 "Install to flash" 2 "Exit to shell" 2>/tmp/dselect >/dev/tty0 </dev/tty0
#choice=`cat /tmp/dselect`
#if [ $choice -eq 1 ]; then
#  dialog $BEGIN --backtitle "$BACKTITLE" --infobox "Starting flash script.." $DIALOGSIZE
#  sleep 2
  /mnt/sd0/sbin/flashstock.sh >/dev/tty0 </dev/tty0
#else
#  dialog $BEGIN --backtitle "$BACKTITLE" --infobox "Exiting to shell.." $DIALOGSIZE
#  sleep 2
#  own-tty /dev/tty0 /bin/bash -bash
#fi

clear > /dev/tty0
fbsplash -s /mnt/sd0/etc/goodbye.ppm -c
poweroff
